//+------------------------------------------------------------------+
//|                                        Vertical_Coloured_RSI.mq4 |
//+------------------------------------------------------------------+
#property copyright "TheXpert"
#property link      "theforexpert@gmail.com"

#property indicator_separate_window

#property indicator_maximum 100
#property indicator_minimum 0

#property indicator_buffers 7

#property indicator_color1 Khaki
#property indicator_color2 DeepSkyBlue
#property indicator_color3 Red
#property indicator_color4 DeepSkyBlue
#property indicator_color5 DeepSkyBlue
#property indicator_color6 Red
#property indicator_color7 Red

//---- input parameters
extern int     RSIPeriod         =  14;
extern int     RSIPrice          =  0;
      
//---- buffers
double RSI[];

double Higher1[];
double Higher2[];

double Lower1[];
double Lower2[];

double HigherTail[];
double LowerTail[];

int init()
{
   SetIndexBuffer(0, RSI);

   SetIndexBuffer(1, HigherTail);
   SetIndexBuffer(2, LowerTail);

   SetIndexBuffer(3, Higher1);
   SetIndexBuffer(4, Higher2);

   SetIndexBuffer(5, Lower1);
   SetIndexBuffer(6, Lower2);

   SetIndexLabel(0, "RSI");
   SetIndexLabel(1, "RSI");
   SetIndexLabel(2, "RSI");
   SetIndexLabel(3, "RSI");
   SetIndexLabel(4, "RSI");
   SetIndexLabel(5, "RSI current value");
   SetIndexLabel(6, "RSI current value");
   
   SetIndexDrawBegin(0, RSIPeriod + 1);
   SetIndexDrawBegin(1, RSIPeriod + 1);
   SetIndexDrawBegin(2, RSIPeriod + 1);   
   SetIndexDrawBegin(3, RSIPeriod + 1);
   SetIndexDrawBegin(4, RSIPeriod + 1);
   SetIndexDrawBegin(5, RSIPeriod + 1);
   SetIndexDrawBegin(6, RSIPeriod + 1);
   
   IndicatorShortName("  RSI");
   
   IndicatorDigits(2);

   return(0);
}

int start()
{
   int ToCount = Bars - IndicatorCounted();

   for (int cnt = ToCount - 1; cnt >= 0; cnt--)
   {
      RSI[cnt] = iRSI(NULL, 0, RSIPeriod, RSIPrice, cnt);
      Higher1[cnt] = EMPTY_VALUE;
      Higher2[cnt] = EMPTY_VALUE;
      Lower1[cnt] = EMPTY_VALUE;
      Lower2[cnt] = EMPTY_VALUE;
      
      if (cnt == 0)
      {
         LowerTail[2] = EMPTY_VALUE;
         HigherTail[2] = EMPTY_VALUE;
         
         if (RSI[0] > RSI[1])
         {
            LowerTail[0] = EMPTY_VALUE;
            LowerTail[1] = EMPTY_VALUE;
            
            HigherTail[0] = RSI[0];
            HigherTail[1] = RSI[1];
         }
         else
         {
            HigherTail[0] = EMPTY_VALUE;
            HigherTail[1] = EMPTY_VALUE;

            LowerTail[0] = RSI[0];
            LowerTail[1] = RSI[1];
         }
         
      }
      else if (RSI[cnt] > RSI[cnt + 1])
      {
         //   
         if (RSI[cnt + 1] > RSI[cnt + 2])
         {
            if (Higher1[cnt + 1] != EMPTY_VALUE)   Higher1[cnt] = RSI[cnt];
            else                                   Higher2[cnt] = RSI[cnt];
         }
         else
         {
            if (Higher1[cnt + 2] == EMPTY_VALUE)   
            {
               Higher1[cnt] = RSI[cnt];
               Higher1[cnt + 1] = RSI[cnt + 1];
            }
            else
            {
               Higher2[cnt] = RSI[cnt];
               Higher2[cnt + 1] = RSI[cnt + 1];
            }
         }
      }
      else
      {
         //   
         if (RSI[cnt + 1] < RSI[cnt + 2])
         {
            if (Lower1[cnt + 1] != EMPTY_VALUE)    Lower1[cnt] = RSI[cnt];
            else                                   Lower2[cnt] = RSI[cnt];
         }
         else
         {
            if (Lower1[cnt + 2] == EMPTY_VALUE)   
            {
               Lower1[cnt] = RSI[cnt];
               Lower1[cnt + 1] = RSI[cnt + 1];
            }
            else
            {
               Lower2[cnt] = RSI[cnt];
               Lower2[cnt + 1] = RSI[cnt + 1];
            }
         }
      }
   }
   
   return(0);
}